import traceback

from cpl_core.console import Console

from bot_api.abc.dto_abc import DtoABC


class TokenDTO(DtoABC):
    def __init__(self, token: str, refresh_token: str):
        DtoABC.__init__(self)

        self._token = token
        self._refresh_token = refresh_token

    @property
    def token(self) -> str:
        return self._token

    @property
    def refresh_token(self) -> str:
        return self._refresh_token

    def from_dict(self, values: dict):
        self._token = values["token"]
        self._refresh_token = values["refreshToken"]

    def to_dict(self) -> dict:
        return {"token": self._token, "refreshToken": self._refresh_token}
