from cpl_query.extension import List

from bot_data.model.auto_role_rule import AutoRoleRule
from bot_graphql.abc.filter_abc import FilterABC


class AutoRoleRuleFilter(FilterABC):
    def __init__(self):
        FilterABC.__init__(self)

        self._id = None
        self._emoji_name = None
        self._role_id = None
        self._auto_role_id = None

    def from_dict(self, values: dict):
        if "id" in values:
            self._id = int(values["id"])

        if "emoji_name" in values:
            self._emoji_name = values["emoji_name"]

        if "role_id" in values:
            self._role_id = int(values["role_id"])

        if "auto_role_id" in values:
            self._auto_role_id = int(values["auto_role_id"])

    def filter(self, query: List[AutoRoleRule]) -> List[AutoRoleRule]:
        if self._id is not None:
            query = query.where(lambda x: x.auto_role_rule_id == self._id)

        if self._auto_role_id is not None:
            query = query.where(lambda x: x.auto_role_id == self._auto_role_id)

        if self._emoji_name is not None:
            query = query.where(lambda x: x.emoji_name == self._emoji_name)

        if self._role_id is not None:
            query = query.where(lambda x: x.role_id == self._role_id)

        # if self._server_id is not None:
        #     query = query.where(lambda x: x.server.server_id == self._server_id)

        return query
