from cpl_query.extension import List

from bot_data.model.level import Level
from bot_graphql.abc.filter_abc import FilterABC


class LevelFilter(FilterABC):
    def __init__(self):
        FilterABC.__init__(self)

        self._id = None
        self._name = None
        self._server_id = None

    def from_dict(self, values: dict):
        if "id" in values:
            self._id = int(values["id"])

        if "name" in values:
            self._name = values["name"]

    def filter(self, query: List[Level]) -> List[Level]:
        if self._id is not None:
            query = query.where(lambda x: x.id == self._id)

        if self._name is not None:
            query = query.where(lambda x: self._name.lower() == x.name.lower() or self._name.lower() in x.name.lower())

        return query
