from bot_data.model.user_joined_voice_channel import UserJoinedVoiceChannel
from bot_graphql.abc.data_query_abc import DataQueryABC


class UserJoinedVoiceChannelQuery(DataQueryABC):
    def __init__(self):
        DataQueryABC.__init__(self, "UserJoinedVoiceChannel")

        self.set_field("id", self.resolve_id)
        self.set_field("channel_id", self.resolve_channel_id)
        self.set_field("user", self.resolve_user)
        self.set_field("server", self.resolve_server)
        self.set_field("joined_on", self.resolve_joined_on)
        self.set_field("leaved_on", self.resolve_leaved_on)

    @staticmethod
    def resolve_id(x: UserJoinedVoiceChannel, *_):
        return x.join_id

    @staticmethod
    def resolve_channel_id(x: UserJoinedVoiceChannel, *_):
        return x.dc_channel_id

    @staticmethod
    def resolve_user(x: UserJoinedVoiceChannel, *_):
        return x.user

    @staticmethod
    def resolve_server(x: UserJoinedVoiceChannel, *_):
        return x.user.server

    @staticmethod
    def resolve_joined_on(x: UserJoinedVoiceChannel, *_):
        return x.joined_on

    @staticmethod
    def resolve_leaved_on(x: UserJoinedVoiceChannel, *_):
        return x.leaved_on
